package ru.kristall.alfresco.module.bg.soap;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.StringReader;
import java.io.StringWriter;
import java.nio.charset.Charset;
import java.util.Enumeration;
import java.util.Hashtable;

import javax.xml.parsers.SAXParser;
import javax.xml.parsers.SAXParserFactory;
import javax.xml.soap.MessageFactory;
import javax.xml.soap.MimeHeader;
import javax.xml.soap.MimeHeaders;
import javax.xml.soap.SOAPBody;
import javax.xml.soap.SOAPConnection;
import javax.xml.soap.SOAPConnectionFactory;
import javax.xml.soap.SOAPElement;
import javax.xml.soap.SOAPEnvelope;
import javax.xml.soap.SOAPException;
import javax.xml.soap.SOAPMessage;
import javax.xml.soap.SOAPPart;
import javax.xml.transform.Source;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.stream.StreamResult;

import oracle.xml.parser.v2.XMLDocument;

import org.apache.soap.Envelope;
import org.w3c.dom.Element;
import org.w3c.dom.Text;
import org.xml.sax.InputSource;
import org.xml.sax.XMLReader;

public class GetSoap {
	
	public GetSoap(){
		url="";
		el_a2=null;
		act="";
	};
	
	private String url;
	private Element el_a2;
	private String act;
	private Hashtable ht;
	private org.alfresco.repo.jscript.ScriptLogger logger;
	
	public void setURL(String p) {url=p;}
	public void setAct(String p) {act=p;}
	public void setValues(Hashtable h) {ht=h;}
	public void setLogger(org.alfresco.repo.jscript.ScriptLogger pLogger) {logger=pLogger;}
	
	public String getRequest() throws Exception {
	    XMLDocument dc = new XMLDocument();
	    Element e_sm = dc.createElementNS("http://schemas.xmlsoap.org/soap/envelope/","Envelope");
	    e_sm.setAttributeNS("http://www.w3.org/2000/xmlns/", "xmlns:kris", "kristallReport");
	    Element e_sb = dc.createElementNS("http://schemas.xmlsoap.org/soap/envelope/","Body");

		//"kris:getTest"
        //addElement(el_a2, "arg0", "488956");
	    logger.error("GetSoap "+"before create Element");
	    Element el_a2 = dc.createElement(act);
	    if (ht!=null) {
	      Enumeration en = ht.keys();
	      String szStr; 
	      while(en.hasMoreElements())  {
	        szStr = (String)en.nextElement();
	        addElement(el_a2, szStr, (String)ht.get(szStr));
	      }
	    }
	    logger.error("GetSoap "+"after get ht");
	    e_sb.appendChild(el_a2);
	    e_sm.appendChild(e_sb);
	    logger.error("GetSoap "+"before envelope unmarshal");
	    Envelope msgEnv = Envelope.unmarshall(e_sm);
	    StringWriter writer = new StringWriter();
	    msgEnv.marshall(writer,null);
    
    
	    SendSOAPMessage ssm = new SendSOAPMessage();
	    SOAPMessage mmm =ssm.getSoapMessageFromString(writer.toString());
	    logger.error("GetSoap "+"soap message "+writer.toString());

	    SOAPConnectionFactory soapConnectionFactory = SOAPConnectionFactory.newInstance();
	    logger.error("GetSoap "+"before create connection");
	    SOAPConnection soapConnection = soapConnectionFactory.createConnection();
	    //String url = "http://10.10.12.202:8080/bgbilling/api/ru.kristall.bgbilling.service/Test";
	    logger.error("GetSoap "+"before call");
	    SOAPMessage soapResponse = soapConnection.call(mmm, url);
	    soapConnection.close();
	    StringBuffer rr = new StringBuffer(ssm.getText(soapResponse));
	    logger.error("GetSoap StringBuffer "+rr.toString());
	    rr.delete(rr.indexOf("</return>"), rr.length());
	    rr.delete(0, rr.indexOf("<return>")+8);
	    logger.error("GetSoap StringBuffer "+rr.toString());    
//	    <ns2:getPDFResponse xmlns:ns2="kristall">
//	     <return>[PDF]BASE64[/PDF][XML]BASE64[/XML]</return>
//	    </ns2:getPDFResponse>		
	    		
	    return rr.toString();
	}
	
    private static void addElement (Element parent, String name, String value )  {
        Element child = parent.getOwnerDocument().createElement(name);
        parent.appendChild(child);
        if (value!=null) {
          Text text = parent.getOwnerDocument().createTextNode(value);
          child.appendChild(text);
        }
        return ;
    }
	
//    XMLDocument dc = new XMLDocument();
//    Element e_sm = dc.createElementNS("http://schemas.xmlsoap.org/soap/envelope/","Envelope");
//    e_sm.setAttributeNS("http://www.w3.org/2000/xmlns/", "xmlns:kris", "kristall");
//    Element e_sb = dc.createElementNS("http://schemas.xmlsoap.org/soap/envelope/","Body");
//
//    
////    Element el_a2 = dc.createElement("kris:getBalanceByContractId");
////    addElement(el_a2, "arg0", "488956");
////    e_sb.appendChild(el_a2);
////    e_sm.appendChild(e_sb);
////    Envelope msgEnv = Envelope.unmarshall(e_sm);
////    StringWriter writer = new StringWriter();
////    msgEnv.marshall(writer,null);
//
//    
//    Element el_a2 = dc.createElement("kris:getTest");
//    e_sb.appendChild(el_a2);
//    e_sm.appendChild(e_sb);
//    Envelope msgEnv = Envelope.unmarshall(e_sm);
//    StringWriter writer = new StringWriter();
//    msgEnv.marshall(writer,null);
//    
//    
//    SendSOAPMessage ssm = new SendSOAPMessage();
//    SOAPMessage mmm =ssm.getSoapMessageFromString(writer.toString());
//
//    SOAPConnectionFactory soapConnectionFactory = SOAPConnectionFactory.newInstance();
//    SOAPConnection soapConnection = soapConnectionFactory.createConnection();
//    String url = "http://10.10.12.202:8080/bgbilling/api/ru.kristall.bgbilling.service/Test";
//    SOAPMessage soapResponse = soapConnection.call(mmm, url);
//    soapConnection.close();
//    String smmm= ssm.getText(soapResponse);
//    System.out.println(smmm);
	

}
